--
-- FollowMe 1.8
--
-- See Readme.txt for documentation
--
FMVer="1.8"
following=nil;
follow_attempt=nil;
follow_request=false;
fm_sender=nil;
fm_Mounted=false;
fm_PlayerName = UnitName("player");
fm_PlayerCasting=false;
fm_SpellIsMount=false;
fm_busy=false;
FMEnabled=true;
tellgrp="on";

MountTable={ "al'ar",
             "bear",
             "broom",
             "charger",
             "chopper",
             "drake",
             "elekk",
             "gryph",
             "strider",
             "horse",
             "kodo",
             "machine",
             "mammoth",
             "mechano",
             "ram",
             "raptor",
             "raven",
             "ray",
             "saber",
             "steed",
             "talbuk",
             "tank",
             "tiger",
             "turtle",
             "wolf",
             "wyvern" }

--================================================================
--
-- Events that make player busy (used to toggle busy-mode on)
--
--================================================================
   busy_events={ "AUCTION_HOUSE_SHOW",
                 "BANKFRAME_OPENED",
                 "GUILDBANKFRAME_OPENED",
                 "GOSSIP_SHOW",
                 "LOOT_OPENED",
                 "UNIT_SPELLCAST_START",
                 "MAIL_SHOW",
                 "TRADE_SHOW",
                 "QUEST_DETAIL",
                 "MERCHANT_SHOW",
                 "TAXIMAP_OPENED",
                 "TRAINER_SHOW"
               }

--================================================================
--
-- Events that make player unbusy (used to toggle busy-mode off)
--
--================================================================
 unbusy_events={ "AUCTION_HOUSE_CLOSED",
                 "BANKFRAME_CLOSED",
                 "GUILDBANKFRAME_CLOSED",
                 "GOSSIP_CLOSED",
                 "LOOT_CLOSED",
                 "UNIT_SPELLCAST_STOP",
                 "MAIL_CLOSED",
                 "TRADE_CLOSED",
                 "QUEST_FINISHED",
                 "MERCHANT_CLOSED",
                 "TAXIMAP_CLOSED",
                 "TRAINER_CLOSED"
               }

--================================================================
--
-- Other events this AddOn has to process (not busy-related)
--
--================================================================
    std_events={ "CHAT_MSG_WHISPER",
                 "UI_ERROR_MESSAGE",
                 "AUTOFOLLOW_BEGIN",
                 "AUTOFOLLOW_END",
                 "ADDON_ACTION_BLOCKED"
               }

--================================================================
--
-- "flag" Table used to store busy events
--
--================================================================
busylist={}

function FollowMe_LocalMsg(txt)
   DEFAULT_CHAT_FRAME:AddMessage(txt);
end

function FollowMe_Print(txt)
   DEFAULT_CHAT_FRAME:AddMessage(txt);
end

function FM_HUDMsg(HudMsg)
   UIErrorsFrame:AddMessage(HudMsg, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
end

--================================================================
--
-- OnLoad handler
--
--================================================================
function FollowMe_OnLoad(self)
   FM_LOAD="FollowMe "..FMVer.." loaded";
   SLASH_FOLLOWME1="/fm";
   SlashCmdList["FOLLOWME"] = FollowMe_CmdParser;

   FollowMe_LocalMsg(FM_LOAD);
   FM_HUDMsg(FM_LOAD);

   -- Hook all of the events to be processed by this AddOn
   for _,v in pairs(busy_events) do
      self:RegisterEvent(v)
   end

   for _,v in pairs(unbusy_events) do
      self:RegisterEvent(v)
   end

   for _,v in pairs(std_events) do
      self:RegisterEvent(v)
   end
end

--================================================================
--
-- Parse the /fm command
--
--================================================================
function FollowMe_CmdParser(parm)
   parm=string.lower(parm);

   -- Code "borrowed" from AutoDruidBuff...
   local x, y, cmd, opr=string.find(parm, "(%w+) (%w+)");
   if ( cmd == nil ) then
      x, y, cmd=string.find(parm, "(%w+)");
      if ( cmd == nil ) then
         FollowMe_LocalMsg("FollowMe v"..FMVer);
         FollowMe_LocalMsg("  Usage: /fm [command]");
         FollowMe_LocalMsg("         status - Reports FollowMe status");
         FollowMe_LocalMsg("         enable - Enables FollowMe");
         FollowMe_LocalMsg("        disable - Disables FollowMe");
         FollowMe_LocalMsg("       announce - Announces to your group that");
         FollowMe_LocalMsg("                  you have the FollowMe AddOn");
         FollowMe_LocalMsg("tellgroup on/off- Toggles sending auto-follow messages to");
         FollowMe_LocalMsg("                  your group");
         FollowMe_LocalMsg("         unbusy - Clears the busy-list. USE CAREFULLY!");
         return;
      end
   end

--================================================================
--
--    Display the group members, with realm name
--
--================================================================
   if ( cmd == "party" ) then
      for i, PartyUnit in pairs({ "party1", "party2", "party3", "party4" }) do
         memName, realmName = UnitName(PartyUnit)
         if ( realmName == nil ) then
            realmName = "None"
         end
         msg=PartyUnit  .. ": " .. memName .. "(" .. realmName .. ")"
         FollowMe_Print(msg)
      end
      return
   end
 
--================================================================
--
-- Display AddOn Status (Enabled, Disabled, Version, Group Spam).
--
--================================================================
   if ( cmd == "status" ) then
      if ( FMEnabled ) then
         msg="Enabled";
      else
         msg="Disabled";
      end
      FollowMe_LocalMsg("FollowMe v"..FMVer..": "..msg );
      FollowMe_LocalMsg("   Group messages are "..tellgrp..".");
      FM_HUDMsg("   Group messages are "..tellgrp..".");
      FM_HUDMsg("FollowMe: "..msg);
      return;
   end

--================================================================
--
-- Announce to the group that you have FollowMe and how to use it.
--
--================================================================
   if ( cmd == "announce" ) then
      if ( GetNumPartyMembers() > 0 ) then
         msg=[[I have the "FollowMe" AddOn Installed.  ]];
         msg=msg..[[If you want me to auto-follow you, send me a whisper with "!follow".]];
         SendChatMessage(msg, "PARTY", nil, nil);
      end
      return;
   end

-- Allow others to put you on AutoFollow
   if ( cmd == "enable" ) then
      FollowMe_LocalMsg("FollowMe Enabled");
      FM_HUDMsg("FollowMe Enabled");
      FMEnabled=true;
      return;
   end

-- Disallow others to put you on AutoFollow
   if ( cmd == "disable" ) then
      FollowMe_LocalMsg("FollowMe Disabled");
      FM_HUDMsg("FollowMe disabled");
      FMEnabled=false;
      return;
   end

-- Set group chat on or off.
   if ( cmd == "tellgroup" ) then
      if (opr == "on" ) then
         tellgrp="on";
      else
         if ( opr == "off") then
             tellgrp="off";
         else
            FollowMe_LocalMsg("/fm tellgroup on/off- Toggles sending auto-follow messages to");
            FollowMe_LocalMsg("your group");
            return;
         end
      end
      FollowMe_LocalMsg("[FollowMe]: Group messages are "..tellgrp);
      FM_HUDMsg("[FollowMe]: Group message are "..tellgrp);
   end

-- Show the busylist
   if ( cmd == "blist" ) then
      FollowMe_LocalMsg("BusyList: ");
      for _,v in pairs(busylist) do
         FollowMe_LocalMsg(v);
      end
   end

   if ( cmd == "unbusy" ) then
      for i=1,table.getn(busylist) do
         table.remove(busylist)
      end
      fm_busy=false;
      FollowMe_LocalMsg("[FollowMe]: Busy-list cleared.")
      FM_HUDMsg("[FollowMe]: Busy-list cleared.")
   end
end

--================================================================
--
-- Whisper Function
--
--================================================================
function FollowMe_SendWhisper(name, message)
   SendChatMessage(message, "WHISPER", nil, name);
end

--========================================================================
--
-- Event handler (receive whisper, UI error, auto-follow begin/end, etc)
--
--========================================================================
function FollowMe_OnEvent(self, event, ...)
   local arg1, arg2, arg3, arg4 = ...;
-- Spell Cast Start
   if (event == "UNIT_SPELLCAST_START") then
      if (UnitName(arg1) == fm_PlayerName) then
         fm_PlayerCasting=true
         if (FollowMe_IsMount(string.lower(arg2)) ~= nil) then
            fm_SpellIsMount=true
         end
      end
      return;
   end

-- Spell Cast Stop
   if ( event == "UNIT_SPELLCAST_STOP") then
      if (UnitName(arg1) == fm_PlayerName) then
         fm_PlayerCasting=false
         if ( follow_request == true ) then
            if ( UnitName(UnitToFollow) == fm_sender ) then
               follow_attempt=1;
               follow_request=false;
               FollowUnit(UnitToFollow);
            end
         end
      end
      return;
   end

-- Chat Message Received --
   if ( event == "CHAT_MSG_WHISPER" ) then
      if ( arg1 and arg2 ) then
         fm_sender=arg2;
         FollowMe_ProcessWhisper(arg1, arg2);
         return
      end
   end

-- Trap UI Errors --
   if ( event == "UI_ERROR_MESSAGE" ) then
      -- Only process this section if the error is generated by this AddOn.
      -- All events are stacked in the AddOn glue, so ERR_GENERIC_NO_TARGET 
      -- from any AddOn would generate FollowMe errors.
      if ( follow_attempt ~=nil ) then
         if ( (arg1 == ERR_AUTOFOLLOW_TOO_FAR)  or (arg1 == ERR_UNIT_NOT_FOUND) ) then
            FollowMe_SendWhisper(fm_sender, "[FollowMe]: I cannot follow you.  You're not close enough.");
         end
         follow_attempt=nil;
         fm_sender=nil;
         fm_SpellIsMount=false;
      end
      return;
   end

-- AutoFollow Begin --
   if ( event == "AUTOFOLLOW_BEGIN" ) then
      following=arg1;
      msg="[FollowMe]: Following you...Lead on...:)"
      if ( following ~= nil ) then
         if ( tellgrp == "on" ) then
            if ( GetNumPartyMembers() > 0) then
               SendChatMessage("[FollowMe]: Auto-follow on "..following, "PARTY", nil, nil);
            end
            follow_attempt=nil;
            fm_sender=nil
         end
         if UnitLevel("Player") >= 20 then
            if IsOutdoors() == 1 then
               if (IsMounted() ~= 1) then
                  if (fm_SpellIsMount ~= true) then
                     msg=msg .. " -- WARNING!!  I'm not on my mount!"
                  end
               end
            end
         end
         FollowMe_SendWhisper(following, msg);
         fm_SpellIsMount=false
         return;
      end
   end

-- AutoFollow End --
   if ( event == "AUTOFOLLOW_END" ) then
      if ( following ~= nil ) then
         FollowMe_SendWhisper(following, "[FollowMe]: I'm no longer following you.");
         if ( tellgrp == "on" ) then
            if ( GetNumPartyMembers() > 0) then
               SendChatMessage("[FollowMe]: I'm no longer auto-following "..following, "PARTY", nil, nil);
            end
         end
         following=nil;
         return;
      end
   end
   
-- Process busy/unbusy events.  Add/remove from busylist{} as
-- appropriate.
   for _,n in pairs(busy_events) do
      if ( n == event ) then
         table.insert(busylist, event)
         fm_busy=true
         return
      end
   end

   for z,n in pairs(unbusy_events) do
      if ( n == event ) then
         busyname=busy_events[z]
         j=1
         for _,bn in pairs(busylist) do
            if ( bn == busyname ) then
               table.remove(busylist,j)
            end
            j=j+1
         end
         if (table.maxn(busylist) == 0) then
            fm_busy=false
         else
            fm_busy=true
         end
         return
      end
   end

end --FollowMe_OnEvent

--========================================================================
-- Parse the received whisper.
-- "!follow" turns on auto-follow
-- "!status" returns the addon status (Enabled/Disabled, who followed).
--========================================================================
function FollowMe_ProcessWhisper(whisper, sender)
   tok=string.sub(whisper,1,1)
   if ( tok ~= "!" ) then
      return;
   end

   if (string.find(whisper, " ") == nil ) then
      cmd=string.lower(whisper);
   else
      cmd=string.lower(string.sub(whisper, 1, string.find(whisper, " ")));
   end

--================================================================
--
-- Do the deal.  This attempts to follow the whisper sender
--
--================================================================
   if ( cmd == "!follow" ) then
      FollowMe_Print([[ DEBUG: Whisper From " ]] ..sender..[["]])
      if ( FMEnabled == false ) then
         FollowMe_SendWhisper(sender, "[FollowMe]: I can't follow you -- FollowMe addon is disabled");
         return;
      end

      -- Follow requestor must be group or raid member
      UnitToFollow=FollowMe_InMyGroup(sender)
      if ( UnitToFollow == nil ) then
         if ( UnitInRaid("player") ) then
            UnitToFollow=FollowMe_InMyRaid(sender)
            if (UnitToFollow == nil ) then
               FollowMe_SendWhisper(fm_sender, "[FollowMe]: I can't follow you -- you're not my raid");
               return;
            end
         else
            FollowMe_SendWhisper(fm_sender, "[FollowMe]: I can't follow you -- we're not grouped");
            return;
         end
      end

      -- Wait until casting is complete
      if ( fm_PlayerCasting == true) then
         msg="[FollowMe]: Hold your horses -- I'm casting here. :)  "
         msg=msg.."I'll start following you when I'm done.";
         FollowMe_SendWhisper(sender, msg);
         follow_request=true;
         return;
      end

      -- Deny follow request if busy
      if ( fm_busy == true ) then
         FollowMe_SendWhisper(sender, "[FollowMe]: I can't follow you.  I'm busy.");
         return
      end

      -- Attempt to follow the sender
      if ( UnitToFollow ~= nil ) then
         if ( UnitName(UnitToFollow) == sender ) then
            follow_attempt=1;
            FollowUnit(UnitToFollow);
         end
      end
   end

--================================================================
--
-- Report the status of this AddOn back to the sender (version,
-- whether or not the AddOn is enabled and who is being followed,
-- if any).
--
--================================================================
   if ( cmd == "!status" ) then
      msg="FollowMe ("..FMVer.."): ";
      if ( FMEnabled == false ) then
         msg=msg.." Disabled";
      else
         msg=msg.." Enabled.";
         if ( following ~= nil ) then
            msg=msg.."  Currently following "..following;
         end
      end
      FollowMe_SendWhisper(sender, msg);
      fm_sender=nil;
   end

   fm_sender=nil;
end

--==============================================================
--
-- This function is based on WhisperCast:
--
--==============================================================
function FollowMe_InMyGroup(name)
   if ( GetNumPartyMembers() > 0 ) then
      for i, PartyUnit in pairs({ "party1", "party2", "party3", "party4" }) do
         if ( name == UnitName(PartyUnit) ) then
            return PartyUnit;
         end
      end
   end
   return nil;
end

--==============================================================
--
-- Check if the requester is in my raid
--
--==============================================================
function FollowMe_InMyRaid(name)
   RaidMembers = GetNumRaidMembers()
   if ( RaidMembers > 0 ) then
      for i=1,RaidMembers do
         RaidUnit,_ = UnitName("raid"..i)
         if ( name == RaidUnit ) then
            return RaidUnit
         end
      end
   end
   return nil
end

--
-- See if the cast spell is a mount.
--
function FollowMe_IsMount(SpellName)
   for _,MountName in pairs(MountTable) do
       if ( string.find (SpellName, MountName) ) then
          return true;
       end
   end
   return nil;
end
